//+------------------------------------------------------------------+
//|                                                        elder.mq4 |
//|                                    Copyright 2012, Guriev Invest |
//|                                   http://www.gurievinvest.org.ua |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Guriev Invest"
#property link      "http://gurieveugen.blogspot.com/2012/06/blog-post.html"

extern int maFast          = 12;       //  
extern int maSlow          = 26;       //  
extern int maSignal        = 9;        //  
extern int Delta           = 3;        //       
extern int LevelWLoss      = 10;       //  
extern int LevelProfit     = 0;        //  ;  0         
extern int MaxRisk         = 2;        //  
extern int MAXLOSS         = 2;        //      

int prevtime   = 0;
int ParentTimeFrame  = PERIOD_W1;

bool TrendUp   = false;
bool TrendDown = false;
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
int CalculateLossOrders()
{
   datetime t;
   int o = 0;
   
   for(int i=0; i<OrdersHistoryTotal(); i++)
   if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY))
   if(OrderSymbol() == Symbol())
   if(OrderType() == OP_BUY || OrderType() == OP_SELL)
   {
      t = OrderCloseTime();
      if(Year() == TimeYear(t) && Month() == TimeMonth(t))
      if(OrderProfit()<0) o++;
   }
   return (o);
}
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void bu()
{
   bool fm;   
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
         if(OrderType() == OP_BUY)
         {
            if(LevelProfit>0)
            {
               if(Bid-OrderOpenPrice() > LevelProfit)
               fm = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+LevelWLoss*Point,OrderTakeProfit(),CLR_NONE);
            }
            else
            {
               if(Bid-OrderOpenPrice() > (OrderOpenPrice()-OrderStopLoss()))
               fm = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+LevelWLoss*Point,OrderTakeProfit(),CLR_NONE);
            }
         }
         if(OrderType() == OP_SELL)
         {
            if(LevelProfit>0)
            {
               if(OrderOpenPrice()-Ask > LevelProfit)
               fm = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-LevelWLoss*Point,OrderTakeProfit(),CLR_NONE);
            }
            else
            {
               if(OrderOpenPrice()-Ask > (OrderStopLoss()-OrderOpenPrice()))
               fm = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-LevelWLoss*Point,OrderTakeProfit(),CLR_NONE);   
            }
         }
         if(fm) break;
      }
   }
}
bool isOrder(int order)
{
   if(OrdersTotal()<1) return (false);
   for(int i = 0; i<OrdersTotal();i++)
   if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
   if(OrderType() == order && OrderSymbol() == Symbol())
   return (true);
}
bool isOrders(int order, bool isBuy)
{
   if(OrdersTotal()<1) return (false);
   for(int i = 0; i<OrdersTotal();i++)
   if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
   {
      if(OrderType() == order && OrderSymbol() == Symbol())
      if(isBuy)
      {
         if(OrderOpenPrice()>High[1])
         {
            OrderDelete(OrderTicket());
            return (false);
         }
         else return (true);
      }
      else
      {
         if(OrderOpenPrice()<Low[1])
         {
            OrderDelete(OrderTicket());
            return (false);
         }
         else return (true);
      }
   }
}
bool Force(bool isBuy)
{
   double force = iForce(Symbol(), Period(), 2, 0, 0, 1);
   if(isBuy)
   {
      if(force>0) return (false);
      else return (true);
   }   
   else
   {
      if(force<0) return (false);
      else return (true);
   }   
}
//+------------------------------------------------------------------+
//|          -      |
//+------------------------------------------------------------------+
double GetLots(double sl)
{
   double Free    = AccountFreeMargin();                    //  
   double LotVal  = MarketInfo(Symbol(),MODE_TICKVALUE);    // 1   1 
   double MinLot  = MarketInfo(Symbol(),MODE_MINLOT);       //  
   double MaxLot  = MarketInfo(Symbol(),MODE_MAXLOT);       //  
   double Step    = MarketInfo(Symbol(),MODE_LOTSTEP);      //   
   double Lot     = MathFloor((Free*MaxRisk/100)/(sl*LotVal)/Step)*Step;
   
   if(Lot<MinLot) Lot = MinLot;
   if(Lot>MaxLot) Lot = MaxLot;
   
   return (Lot);
}
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(Time[0] == prevtime) return (0);
   prevtime = Time[0];
   
   bool up        = false;
   bool down      = false;
   
   
   double TakeProfit = 0;
   double Lots    = NormalizeDouble((AccountBalance()/10000),2);   
   double macd1   = iMACD(Symbol(), ParentTimeFrame, maFast, maSlow, maSignal, PRICE_CLOSE, MODE_MAIN,1);    
   double macd2   = iMACD(Symbol(), ParentTimeFrame, maFast, maSlow, maSignal, PRICE_CLOSE, MODE_MAIN,2);
   double macd3   = iMACD(Symbol(), ParentTimeFrame, maFast, maSlow, maSignal, PRICE_CLOSE, MODE_MAIN,3);
   
   
   //========= =========
   if(macd1>macd2 && macd2<macd3)
   {
      TrendUp = true;
      TrendDown = false;
   }
   else if(macd1<macd2 && macd2>macd3)
   {
      TrendUp = false;
      TrendDown = true;
   }
   
   if(TrendUp) up = Force(true);
   if(TrendDown) down = Force(false);
   
   if(CalculateLossOrders()>MAXLOSS-1){up = false; down = false;}
   
   if(up)
   {
      if(!isOrders(OP_BUYSTOP, true) && !isOrder(OP_BUY))
      {
         TakeProfit = High[1] + ((High[1]-Low[1])*Delta);
         OrderSend(Symbol(), OP_BUYSTOP, GetLots((High[1]-Low[1])*100000), High[1], 1, Low[1], TakeProfit, "",0,0, Green);
      }
   }
   if(down)
   {
      if(!isOrders(OP_SELLSTOP, false) && !isOrder(OP_SELL))
      {
         TakeProfit = Low[1] - ((High[1]-Low[1])*Delta);
         OrderSend(Symbol(), OP_SELLSTOP, GetLots((High[1]-Low[1])*100000), Low[1], 1, High[1], TakeProfit, "",0,0, Red);
      }
   }   
   bu();
   //==================================   
   return(0);
  }
//+------------------------------------------------------------------+